source("pest.tech.functions.R")    

# Define server logic required to summarize and view the selected dataset
shinyServer(function(input, output) {

  
  
  data<-reactive({
  #Read in the values from the ui
    trap.space.x<-input$trap.space.x
    trap.space.y<-input$trap.space.y
    traps.in.x<-input$traps.in.x
    traps.in.y<-input$traps.in.y
    g0<-input$g0
    sigma<-input$sigma
    max.catch<-input$max.catch
    n.nights<-input$n.nights
    density<-input$density    
  start.xy<-c(1000,1000)	#Don't need to change this
	buffer<-100
  dist.type<-input$dist.type
    reps<-input$reps




    
dens.vector<-density
    d<-1
#Set up matrices to hold the results
n.caught<-rep(NA,reps)
p.caught<-rep(NA,reps)
t.caught<-rep(NA,reps)
    night.caught<-matrix(NA,reps,n.nights)
p.summ<-matrix(NA,length(dens.vector),3)
t.catch<-rep(0,13)

    hist.brks<-c(-.5,0.5,1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5)

pb <- winProgressBar(title = "progress bar", min = 0, max = length(dens.vector)*reps, width = 300)
  for(s in 1:reps){
    
    
    
#---------Make the traps from these input parameters above
  trap.info<-trap.make.func(traps.in.x, traps.in.y, trap.space.x, trap.space.y, buffer, start.xy)
# 	print(paste(trap.info$trap.area, "ha"))

	xlims<-trap.info$xlims	
	ylims<-trap.info$ylims
	traps<-trap.info$traps
	n.traps<-trap.info$n.traps
	total.area<-trap.info$total.area
	trap.area<-trap.info$trap.area    
    
    
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#----1. Simulate animal locations.
animal.locs<-animal.loc.func(xlims, ylims, total.area, density, dist.type)
  animals<-animal.locs$animals
	n.animals<-animal.locs$n.animals
	dist.type<-animal.locs$dist.type

#---2. Calculate the distance between each trap/animal and the prob of capture
    #Problem here with allocation of memory...fixed with setting sd to 3?
  rm(dist.prob, prob.xy)
  gc()
dist.prob<-dist.prob.func(n.animals, animals, n.traps, traps, g0, sigma,3)
	prob.xy<-dist.prob	#$prob.xy,  #	dist2.xy<-dist.prob$dist2.xy

#---3. Simulate the captures
    #Can also get a problem here with memory allocation
  rm(trap.animals, caught.traps, trap.catch, sim.captures)
  gc()
  sim.captures<-sim.captures.simple.func(n.traps, n.nights, n.animals,max.catch, prob.xy)
	trap.animals<-sim.captures$trap.animals
	trap.catch<-sim.captures$trap.catch
	caught.traps<-sim.captures$caught.traps    


  night.caught[s,]<-cumsum(colSums(trap.catch))/n.animals
  
  n.caught[s]<-sum(trap.animals)
	p.caught[s]<-sum(trap.animals)/n.animals
  
  t.catch.tmp<-hist(rowSums(trap.catch),hist.brks, plot=FALSE)$counts
  t.catch<- t.catch+t.catch.tmp
  t.caught[s]<-sum(t.catch.tmp[2:(length(t.catch.tmp)-1)])/sum(t.catch.tmp)
	#Store histogram of trap catches (after n.nights)
# 	t.catch[d,]<- t.catch[d,]+hist(rowSums(trap.catch),hist.brks, plot=FALSE)$counts

si<-((d-1)*reps)+s
setWinProgressBar(pb, si, title=paste("Density = ", density, ", Rep =",s," (", round(si/(length(dens.vector)*reps)*100, 0),"% done)"))
	}  

#The number of animals that each trap catches...
names(t.catch)<-c(0,1,2,3,4,5,6,7,8,9,10,11,12)    
t.catch<-t.catch/reps
t.catch<-t.catch[1:(max.catch+1)]    
close(pb)   
    
#Summary    
data.summary<-as.data.frame(matrix(NA,2,2))
rownames(data.summary)<-c("Animals caught", "Traps with captures")
colnames(data.summary)<-c("Mean", "SD")
data.summary[1,1]<-mean((p.caught))#Proportion of animals caught (number would be n.caught)
data.summary[1,2]<-sd((p.caught))#Proportion of animals caught (number would be n.caught)
data.summary[2,1]<-mean(t.caught)#Prop of traps with captures
data.summary[2,2]<-sd(t.caught)#Prop of traps with captures
# trap.catch is traps*nights but number of animals per trap
# caught,traps is whether the trap caught anything during the study...
# data.summary<-n.caught    
night.caught.mean<-colMeans(night.caught)    
#Return the values...
    return(list(animals=animals,traps=traps,xlims=xlims, ylims=ylims, trap.catch=trap.catch, n.animals=n.animals,n.traps=n.traps, total.area=total.area, trap.area=trap.area, g0=g0,sigma=sigma, max.catch=max.catch, n.nights=n.nights, data.summary=data.summary, n.caught=n.caught, p.caught=p.caught, t.catch=t.catch, night.caught.mean=night.caught.mean))
#       return(list(animals=animals,traps=traps,xlims=xlims, ylims=ylims, n.animals=n.animals,n.traps=n.traps, total.area=total.area, trap.area=trap.area, g0=g0,sigma=sigma, max.catch=max.catch, n.nights=n.nights))
    
  })#End of function....
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



output$main_plot <- renderPlot( {

#~~~~~~~~~~~~~~~~~~~~ Do the plots ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
par(mar=c(4,5,6,1))
par(layout(matrix(c(1,1,2,1,1,3,1,1,4),3,3,byrow=TRUE)))
traps<-data()$traps
pch.trap<-ifelse(data()$max.catch==1,3,8)  #
animals<-data()$animals

plot(traps[,2:3], pch=pch.trap, col="red", xlim=data()$xlims, ylim=data()$ylims, asp=1, cex=.9)
points(animals$xloc, animals$yloc, col=rgb(0,0,1,.8), pch=20, cex=2)
mtext(paste("Number of animals = ",data()$n.animals),3, padj=-1, adj=0)
mtext(paste("Number of traps = ",data()$n.traps),3, padj=-2.5, adj=0)
mtext(paste("Total area = ",round(data()$total.area,0),"ha",", Trap area = ",round(data()$trap.area,0),"ha"),3, padj=-4, adj=0)


#~~~~~~~~Plot distance vs prob from g0 and sigma~~~~~~~~~
#Calculate what the probability of capture will be:
#i.e.  P(Cap) = dnorm(distance,sd=sigma)*g0/dnorm(0,sigma)
#g0<-data()$g0
#sigma<-data()$sigma
#plot.g0.sigma(g0,sigma)
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# #---Plot of cumulative traps occupied by time
plot(1,1, type="n",pch=20,xlim=c(0,data()$n.nights), ylim=c(0,1), xlab="Nights" ,las=1, ylab="Proportion", bty="n")
lines(1:data()$n.nights, data()$night.caught.mean,pch=16,  col="blue", type="b")
#lines(1:data()$n.nights, cumsum(colSums(data()$trap.catch))/(data()$n.traps*data()$max.catch),pch=16, type="b",col="red")
lines(1:data()$n.nights,rowMeans(apply(data()$trap.catch,1,cumsum)==input$max.catch),pch=16, type="b", col="red")
legend("topleft",legend=c("Animals caught","Traps full"), col=c("blue","red"), pch=16, lty=1, bty="n")
mtext("Cumulative by time",3)



hist((data()$p.caught), main="") #Propotion of animals caught
mtext("Proportion caught")
barplot((data()$t.catch), las=1) #Captures per trap
mtext("Captures per trap")
})
    # Generate a summary of the dataset
  output$summary1 <- renderPrint({
        (round(data()$data.summary,3))
  })
        
        
  output$summary2 <- renderPrint( {        
        data()$t.catch
  })
  output$summary3 <- renderPrint( {        
    round(data()$night.caught.mean,4)
  })

  
})

